Package com.io7m.waxmill.xml.vm.v1

# Class WXM1OpenOptions

java.lang.Object
com.io7m.waxmill.xml.vm.v1.WXM1OpenOptions

All Implemented Interfaces:
  `WXM1OpenOptionsType`

    public final class WXM1OpenOptions
    extends java.lang.Object
    implements WXM1OpenOptionsType

Immutable implementation of `WXM1OpenOptionsType`.

Use the builder to create immutable instances: `WXM1OpenOptions.builder()`.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `WXM1OpenOptions.Builder` | Builds instances of type `WXM1OpenOptions`.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `static WXM1OpenOptions.Builder` | `builder()` | Creates a builder for `WXM1OpenOptions`.
  `static WXM1OpenOptions` | `copyOf​(WXM1OpenOptionsType instance)` | Creates an immutable copy of a `WXM1OpenOptionsType` value.
  `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `WXM1OpenOptions` that have equal attribute values.
  `int` | `hashCode()` | Computes a hash code from attributes: `openOptions`.
  `java.util.List<WXMOpenOption>` | `openOptions()` |
  `java.lang.String` | `toString()` | Prints the immutable value `WXM1OpenOptions` with attribute values.
  `WXM1OpenOptions` | `withOpenOptions​(WXMOpenOption... elements)` | Copy the current immutable object with elements that replace the content of `openOptions`.
  `WXM1OpenOptions` | `withOpenOptions​(java.lang.Iterable<? extends WXMOpenOption> elements)` | Copy the current immutable object with elements that replace the content of `openOptions`.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### openOptions

    public java.util.List<WXMOpenOption> openOptions()
    Specified by:
      `openOptions` in interface `WXM1OpenOptionsType`
    Returns:
      The value of the `openOptions` attribute

  - ### withOpenOptions

    public final WXM1OpenOptions withOpenOptions​(WXMOpenOption... elements)
    Copy the current immutable object with elements that replace the content of `openOptions`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withOpenOptions

    public final WXM1OpenOptions withOpenOptions​(java.lang.Iterable<? extends WXMOpenOption> elements)
    Copy the current immutable object with elements that replace the content of `openOptions`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of openOptions elements to set
    Returns:
      A modified copy of `this` object

  - ### equals

    public boolean equals​(java.lang.Object another)
    This instance is equal to all instances of `WXM1OpenOptions` that have equal attribute values.
    Overrides:
      `equals` in class `java.lang.Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `openOptions`.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      hashCode value

  - ### toString

    public java.lang.String toString()
    Prints the immutable value `WXM1OpenOptions` with attribute values.
    Overrides:
      `toString` in class `java.lang.Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static WXM1OpenOptions copyOf​(WXM1OpenOptionsType instance)
    Creates an immutable copy of a `WXM1OpenOptionsType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable WXM1OpenOptions instance

  - ### builder

    public static WXM1OpenOptions.Builder builder()
    Creates a builder for `WXM1OpenOptions`.

         WXM1OpenOptions.builder()
            .addOpenOptions|addAllOpenOptions(com.io7m.waxmill.machines.WXMOpenOption) // openOptions elements
            .build();

    Returns:
      A new WXM1OpenOptions builder